/*
 * This Java source file was generated by the Gradle 'init' task.
 */

import io.vertx.core.Future;
import io.vertx.core.Handler;
import io.vertx.core.MultiMap;
import io.vertx.core.Vertx;
import io.vertx.core.http.*;
import io.vertx.core.logging.Logger;
import io.vertx.core.logging.LoggerFactory;
import io.vertx.ext.unit.*;
import io.vertx.ext.unit.junit.VertxUnitRunnerWithParametersFactory;
import it.unibo.sd1819.lab6.webchat.Service;
import it.unibo.sd1819.lab6.webchat.presentation.*;
import it.unibo.sd1819.lab6.webchat.security.JsonWebToken;
import org.apache.commons.collections4.KeyValue;
import org.apache.commons.collections4.keyvalue.DefaultKeyValue;
import org.junit.After;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.junit.runners.Parameterized;

import java.io.IOException;
import java.time.Duration;
import java.time.OffsetDateTime;
import java.util.*;
import java.util.concurrent.*;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

import static io.vertx.core.http.HttpMethod.*;
import static it.unibo.sd1819.lab6.webchat.presentation.ChatRoom.AccessLevel.*;
import static it.unibo.sd1819.lab6.webchat.presentation.MIMETypes.*;
import static it.unibo.sd1819.lab6.webchat.security.JsonWebToken.Header.*;

@RunWith(Parameterized.class)
@Parameterized.UseParametersRunnerFactory(VertxUnitRunnerWithParametersFactory.class)
public class TestMainApiVerticle {
    protected static final Logger LOGGER = LoggerFactory.getLogger(TestMainApiVerticle.class);
    private static final long MAX_WAIT = 3000;


    private static final String BASE_URL = "/web-chat/v2";

    private static final String NO_TOKEN = null;
    private static String ADMIN_TOKEN;
    private static String USER_TOKEN;

    private static final ChatRoom NO_ROOM = null;
    private static final ChatRoom EMPTY_ROOM = new ChatRoom();

    private static final String NO_HEADER = null;
    private static final Representation NO_BODY = null;

    @Parameterized.Parameters
    public static Iterable<String> data() {
        return Arrays.asList(APPLICATION_JSON, APPLICATION_XML, APPLICATION_YAML);
    }

    private static Vertx vertx;

    @BeforeClass
    public static void setUpClass() {
        vertx = Vertx.vertx();
    }

    @Before
    public void setUp(TestContext context) throws InterruptedException, TimeoutException, ExecutionException {
        final CountDownLatch latch4Server = new CountDownLatch(1);
        vertx.deployVerticle(Service.class.getName(), x -> latch4Server.countDown());
        latch4Server.await();

        ADMIN_TOKEN = "JWT " + getTokenForUserSync(new User().setUsername("admin").setPassword("admin"));
        USER_TOKEN = "JWT " + getTokenForUserSync(new User().setUsername("user").setPassword("user"));
    }

    @After
    public void tearDown() throws InterruptedException {
        final Set<String> ids = vertx.deploymentIDs();
        final CountDownLatch latch = new CountDownLatch(ids.size());
        ids.forEach(id -> vertx.undeploy(id, x -> {
            latch.countDown();
        }));
        latch.await();
    }


    private final String mimeType;

    public TestMainApiVerticle(String mimeType) {
        this.mimeType = mimeType;
    }

    private String getTokenForUserSync(User credentials) throws InterruptedException, ExecutionException, TimeoutException {
        return getTokenForUserSync(credentials, Optional.empty());
    }

    private String getTokenForUserSync(User credentials, Optional<Integer> duration) throws InterruptedException, ExecutionException, TimeoutException {
        final CompletableFuture<String> token = new CompletableFuture<>();
        request(POST, "/auth/token", NO_TOKEN, mimeType, APPLICATION_JWT, duration.map(d -> query("duration", d)).orElse(null))
                .handler(res -> {
                    if (res.statusCode() != 200) {
                        token.completeExceptionally(new IllegalStateException("No valid token for user: " + credentials));
                    } else {
                        res.bodyHandler(body -> {
                            if (body != null || body.length() > 0) {
                                token.complete(body.toString());
                            } else {
                                token.completeExceptionally(new IllegalStateException("No valid token for user: " + credentials));
                            }
                        });
                    }
                }).end(
                credentials.toMIMETypeString(mimeType)
        );
        return token.get(MAX_WAIT, TimeUnit.MILLISECONDS);
    }

    private static KeyValue<String, Object> query(String key, Object value) {
        return new DefaultKeyValue<>(key, value);
    }

    private HttpClientRequest request(HttpMethod method, String path, String token, String contentType, String accept, KeyValue<String, Object>... queries) {
        final String queryString = Arrays.stream(queries)
                .filter(Objects::nonNull)
                .map(kv -> kv.getKey() + "=" + kv.getValue().toString())
                .collect(Collectors.joining("&", "?", ""));
        HttpClientRequest temp = vertx.createHttpClient().request(method, 8080, "localhost", BASE_URL + path + queryString);
        if (token != null) {
            temp = temp.putHeader("Authorization", token);
        }
        if (contentType != null) {
            temp = temp.putHeader("Content-Type", contentType);
        }
        if (accept != null) {
            temp = temp.putHeader("Accept", accept);
        }
        return temp;
    }

    private HttpClient openWebSocketConnection(String path, String token, String contentType, String accept, Handler<WebSocket> wsHandler) {
        return openWebSocketConnection(path, token, contentType, accept, Stream.empty(), wsHandler);
    }

    private HttpClient openWebSocketConnection(String path, String token, String contentType, String accept, Stream<KeyValue<String, Object>> queries, Handler<WebSocket> wsHandler) {
        final String queryString = queries
                .map(kv -> kv.getKey() + "=" + kv.getValue().toString())
                .collect(Collectors.joining("&", "?", ""));
        MultiMap headers = MultiMap.caseInsensitiveMultiMap();
        if (token != null) {
            headers.add("Authorization", token);
        }
        if (contentType != null) {
            headers.add("Content-Type", contentType);
        }
        if (accept != null) {
            headers.add("Accept", accept);
        }
        return vertx.createHttpClient().websocket(8080, "localhost", BASE_URL + path + queryString, headers, wsHandler);
    }

    private void getUserFromLinkAsync(String link, Consumer<User> continuation) {
        final Future<User> futureResult = Future.future();
        final Function<User, Void> actualContinuation = user -> {
            continuation.accept(user);
            return null;
        };
        futureResult.otherwise(e -> null).map(actualContinuation);

        request(GET, link.substring(link.indexOf("/users")) , ADMIN_TOKEN, APPLICATION_JSON, APPLICATION_JSON)
                .handler(res -> {
                    if (res.statusCode() != 200) {
                        futureResult.fail(new IllegalStateException());
                    } else res.bodyHandler(body -> {
                        try {
                            final User user = User.parse(APPLICATION_JSON, body.toString());
                            futureResult.complete(user);
                        } catch (Throwable e) {
                            futureResult.fail(e);
                        }
                    });
                }).end();
    }

    private ChatMessage postMessageSync(String token, String room, String message) {
        final CountDownLatch latch = new CountDownLatch(1);
        final Future<ChatMessage> futureResult = Future.future();
        futureResult.otherwise(e -> null).map(x -> {
            latch.countDown();
            return x;
        });

        request(POST, "/rooms/" + room + "/messages", token, APPLICATION_JSON, APPLICATION_JSON)
                .handler(res -> {
                    if (res.statusCode() != 200) {
                        futureResult.fail(new IllegalStateException());
                    } else res.bodyHandler(body -> {
                        try {
                            final ChatMessage result = ChatMessage.parse(APPLICATION_JSON, body.toString());
                            futureResult.complete(result);
                        } catch (Throwable e) {
                            futureResult.fail(e);
                        }
                    });
                }).end(
                new ChatMessage().setContent(message).toMIMETypeString(APPLICATION_JSON)
        );

        try {
            latch.await(MAX_WAIT, TimeUnit.MILLISECONDS);
            return futureResult.result();
        } catch (InterruptedException e) {
            throw new IllegalStateException(e);
        }
    }

    @Test
    public void testToken(TestContext context) throws InterruptedException, ExecutionException, TimeoutException, IOException {
        final int SECONDS_OF_VALIDITY = 2;
        final String tokenString = getTokenForUserSync(new User().setUsername("user").setPassword("user"), Optional.of(SECONDS_OF_VALIDITY));
        final JsonWebToken token = JsonWebToken.fromBase64(tokenString);

        context.assertNotNull(token);
        context.assertNotNull(token.getHeader());
        context.assertNotNull(token.getPayload());
        context.assertNotNull(token.getSignature());

        context.assertTrue(
                Stream.of("JWT", "jwt", "application/jwt")
                        .anyMatch(typ -> typ.equalsIgnoreCase(token.getHeader().getTyp()))
        );

        context.assertTrue(
                Stream.of(ALG_SIMPLE_MAC, ALG_SIMPLE_HMAC, ALG_HMAC_SHA_256, ALG_HMAC_SHA_512)
                        .anyMatch(alg -> alg.equalsIgnoreCase(token.getHeader().getAlg()))
        );

        context.assertNotNull(token.getPayload().getJid());
        context.assertNotNull(token.getPayload().getExp());
        context.assertNotNull(token.getPayload().getIat());
        context.assertNotNull(token.getPayload().getSub());
        context.assertNotNull(token.getPayload().getUser());
        context.assertNull(token.getPayload().getUser().getPassword());

        context.assertEquals("user", token.getPayload().getUser().getUsername());
        context.assertEquals(
                token.getPayload().getSub(),
                token.getPayload().getUser().getLink().getUrl()
        );
        context.assertEquals(User.Role.USER, token.getPayload().getUser().getRole());

        context.assertEquals(
                token.getPayload().getExp(),
                token.getPayload().getIat().plus(Duration.ofSeconds(SECONDS_OF_VALIDITY))
        );

        context.assertTrue(token.verify());

        Thread.sleep(SECONDS_OF_VALIDITY * 1000L);

        context.assertFalse(token.verify());
    }

    @Test
    public void testStream(TestContext context) {
        final int MAX = 20;
        Async async = context.async(MAX);

        openWebSocketConnection("/rooms/wellcome/messages/stream", USER_TOKEN, NO_HEADER, mimeType, Stream.of(query("skip", 1)), ws -> {
            ws.frameHandler(frame -> {
                if (!frame.isText()) return;
                try {
                    final ChatMessage message = ChatMessage.parse(mimeType, frame.textData());
                    context.assertNotNull(message);
                    if (message.getIndex() >= MAX + 1) {
                        ws.close((short) 200);
                    }
                } catch (IOException e) {
                    context.fail();
                } finally {
                    async.countDown();
                }
            });
        });

        IntStream.range(0, MAX).forEach(i -> {
            final String baseMessage = UUID.randomUUID().toString();
            final ChatMessage message = postMessageSync(USER_TOKEN, "wellcome", baseMessage + " " + i);
            context.assertNotNull(message);
        });

        async.await();
    }

    @Test
    public void testAdminsCanAddAdmins(TestContext context) {
        Async async = context.async();

        final String suffix = mimeType.substring(mimeType.indexOf("/") + 1);

        final User newUser = new User()
                .setUsername("user-" + suffix)
                .setEmail(String.format("user.%s@email.com", suffix))
                .setPassword("password-" + suffix)
                .setRole(User.Role.ADMIN);

        request(POST, "/users", ADMIN_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final Link result = Link.parse(mimeType, body.toString());
                            context.assertEquals(
                                    BASE_URL + "/users/" + newUser.getUsername(),
                                    result.getUrl()
                            );

                            getUserFromLinkAsync(result.getUrl(), u -> {
                                try {
                                    context.assertEquals(User.Role.ADMIN, u.getRole());
                                } finally {
                                    async.complete();
                                }
                            });

                        } catch (Throwable e) {
                            context.fail(e);
                            async.complete();
                        }
                    });
                }).end(
                newUser.toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }


    @Test
    public void testNotAllUsersExists(TestContext context) {
        Async async = context.async();

        request(GET, "/users/non-existing-user", USER_TOKEN, NO_HEADER, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotDeleteNonExistingUsers(TestContext context) {
        Async async = context.async();

        request(DELETE, "/users/non-existing-user", ADMIN_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    private void assertMessagesListsAreEqual(TestContext context, List<ChatMessage> expected, ListOfMessages actual) {
        context.assertEquals(expected.size(), actual.getMessages().size());
        IntStream.range(0, expected.size()).forEach(i -> {
            final ChatMessage expectedMessage = expected.get(i);
            final ChatMessage actualMessage = actual.getMessages().get(i);
            context.assertEquals(expectedMessage.getIndex(), actualMessage.getIndex());
            context.assertEquals(expectedMessage.getContent(), actualMessage.getContent());
            context.assertEquals(expectedMessage.getTimestamp(), actualMessage.getTimestamp());
            context.assertEquals(expectedMessage.getChatRoom(), actualMessage.getChatRoom());
            context.assertEquals(expectedMessage.getSender().getLink(), actualMessage.getSender().getLink());
        });
    }

    @Test
    public void testMessageRetrieval(TestContext context) {
        Async async = context.async(3);

        try {
            final LinkedList<ChatMessage> messages = new LinkedList<>();

            IntStream.range(0, 20).forEach(i -> {
                final String baseMessage = i < 10 ? "some message A " : "other message B ";
                final ChatMessage message = postMessageSync(USER_TOKEN, "wellcome", baseMessage + i);
                context.assertNotNull(message);
                messages.addFirst(message);
            });

            request(GET, "/rooms/wellcome/messages", NO_TOKEN, NO_HEADER, mimeType, query("limit", "20"))
                    .handler(res -> {
                        res.bodyHandler(body -> {
                            try {
                                context.assertEquals(200, res.statusCode());
                                final ListOfMessages result = ListOfMessages.parse(mimeType, body.toString());

                                assertMessagesListsAreEqual(context, messages, result);
                            } catch (Throwable e) {
                                context.fail(e);
                            } finally {
                                async.countDown();
                            }
                        });
                    }).end();

            request(GET, "/rooms/wellcome/messages", NO_TOKEN, NO_HEADER, mimeType, query("limit", 10), query("skip", 10))
                    .handler(res -> {
                        res.bodyHandler(body -> {
                            try {
                                context.assertEquals(200, res.statusCode());
                                final ListOfMessages result = ListOfMessages.parse(mimeType, body.toString());

                                assertMessagesListsAreEqual(context, messages.subList(10, 20), result);
                            } catch (Throwable e) {
                                context.fail(e);
                            } finally {
                                async.countDown();
                            }
                        });
                    }).end();

            request(GET, "/rooms/wellcome/messages", NO_TOKEN, NO_HEADER, mimeType, query("filter", "other"))
                    .handler(res -> {
                        res.bodyHandler(body -> {
                            try {
                                context.assertEquals(200, res.statusCode());
                                final ListOfMessages result = ListOfMessages.parse(mimeType, body.toString());

                                assertMessagesListsAreEqual(context, messages.subList(0, 10), result);
                            } catch (Throwable e) {
                                context.fail(e);
                            } finally {
                                async.countDown();
                            }
                        });
                    }).end();

        } catch (Throwable t) {
            context.fail(t);
            async.complete();
        }

        async.await(MAX_WAIT);
    }

    @Test
    public void testNotAllChatRoomsExists(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/non-existing-room", NO_TOKEN, NO_HEADER, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotDeleteNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(DELETE, "/rooms/non-existing-room", ADMIN_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotAddMessagesToNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(POST, "/rooms/non-existing-room/messages", ADMIN_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end(
                new ChatMessage().setContent("ciao").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotGetMessagesOfNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/non-existing-room/messages", ADMIN_TOKEN, NO_HEADER, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotGetMembersOfNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/non-existing-room/members", ADMIN_TOKEN, NO_HEADER, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotAddMembersToNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(POST, "/rooms/non-existing-room/members", ADMIN_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end(
                new User().setUsername("user").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotDeleteMembersFromNonExistingRooms(TestContext context) {
        Async async = context.async();

        request(DELETE, "/rooms/non-existing-room/members/user", ADMIN_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testCannotDeleteNonExistingMembersFromRooms(TestContext context) {
        Async async = context.async();

        request(DELETE, "/rooms/wellcome/members/non-existing-user", ADMIN_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(404, res.statusCode());

                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testAUserCannotEditSomeoneElseData(TestContext context) {
        Async async = context.async();

        request(PUT, "/users/user", ADMIN_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    try {
                        context.assertEquals(403, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end(
                new User().setUsername("new-username").setEmail("new.email@studio.unibo.it").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testAUserCanEditItsData(TestContext context) {
        Async async = context.async();

        request(PUT, "/users/user", USER_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final User newUserData = User.parse(mimeType, body.toString());
                            context.assertEquals("new-username", newUserData.getUsername());
                            context.assertEquals("new.email@studio.unibo.it", newUserData.getEmail());
                            context.assertTrue(newUserData.getId() != null);
                            context.assertEquals(new Link(BASE_URL + "/users/new-username"), newUserData.getLink());
                            context.assertEquals("User Resu", newUserData.getFullName());
                        } catch (Throwable e) {
                            context.fail(e);
                        } finally {
                            async.complete();
                        }
                    });
                }).end(
                new User().setUsername("new-username").setEmail("new.email@studio.unibo.it").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testUsersCannotAddAdmins(TestContext context) {
        Async async = context.async();

        final String suffix = mimeType.substring(mimeType.indexOf("/") + 1);

        final User newUser = new User()
                .setUsername("user-" + suffix)
                .setEmail(String.format("user.%s@email.com", suffix))
                .setPassword("password-" + suffix)
                .setRole(User.Role.ADMIN);

        request(POST, "/users", USER_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final Link result = Link.parse(mimeType, body.toString());
                            context.assertEquals(
                                    BASE_URL + "/users/" + newUser.getUsername(),
                                    result.getUrl()
                            );

                            getUserFromLinkAsync(result.getUrl(), u -> {
                                try {
                                    context.assertEquals(User.Role.USER, u.getRole());
                                } finally {
                                    async.complete();
                                }
                            });

                        } catch (Throwable e) {
                            context.fail(e);
                            async.complete();
                        }
                    });
                }).end(
                newUser.toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testUnloggedCannotAddAdmins(TestContext context) {
        Async async = context.async();

        final String suffix = mimeType.substring(mimeType.indexOf("/") + 1);

        final User newUser = new User()
                .setUsername("user-" + suffix)
                .setEmail(String.format("user.%s@email.com", suffix))
                .setPassword("password-" + suffix)
                .setRole(User.Role.ADMIN);

        request(POST, "/users", NO_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final Link result = Link.parse(mimeType, body.toString());
                            context.assertEquals(
                                    BASE_URL + "/users/" + newUser.getUsername(),
                                    result.getUrl()
                            );

                            getUserFromLinkAsync(result.getUrl(), u -> {
                                try {
                                    context.assertEquals(User.Role.USER, u.getRole());
                                } finally {
                                    async.complete();
                                }
                            });

                        } catch (Throwable e) {
                            context.fail(e);
                            async.complete();
                        }
                    });
                }).end(
                newUser.toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testPostUserIsPublic(TestContext context) {
        Async async = context.async();

        final String suffix = mimeType.substring(mimeType.indexOf("/") + 1);

        final User newUser = new User()
                .setUsername("user-" + suffix)
                .setEmail(String.format("user.%s@email.com", suffix))
                .setPassword("password-" + suffix);

        request(POST, "/users", NO_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final Link result = Link.parse(mimeType, body.toString());
                            context.assertEquals(
                                    BASE_URL + "/users/" + newUser.getUsername(),
                                    result.getUrl()
                            );
                        } catch (IOException e) {
                            context.fail();
                        } finally {
                            async.complete();
                        }
                    });
                }).end(
                newUser.toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testGetRoomIsPublic(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/wellcome", NO_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final ChatRoom result = ChatRoom.parse(mimeType, body.toString());
                            context.assertEquals("wellcome", result.getName());
                            context.assertEquals(1, result.getMembersCount());
                            context.assertEquals(1, result.getMessagesCount());
                            context.assertEquals(1, result.getMembers().size());
                            context.assertEquals(1, result.getMessages().size());
                            context.assertEquals(new Link(BASE_URL + "/rooms/wellcome"), result.getLink());
                            context.assertEquals(new Link(BASE_URL + "/users/user"), result.getMembers().get(0).getLink());
                            context.assertEquals(new Link(BASE_URL + "/users/admin"), result.getOwner().getLink());
                            context.assertEquals(0, result.getMessages().get(0).getIndex());
                        } catch (IOException e) {
                            LOGGER.error(e);
                            context.fail();
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testGetRoomMessagesIsPublic(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/wellcome/messages", NO_TOKEN, NO_HEADER, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final ListOfMessages result = ListOfMessages.parse(mimeType, body.toString());
                            context.assertEquals(1, result.getMessages().size());
                            final ChatMessage message = result.getMessages().get(0);
                            context.assertEquals(0, message.getIndex());
                            context.assertEquals(new Link(BASE_URL + "/rooms/wellcome"), message.getChatRoom());
                            context.assertEquals(new Link(BASE_URL + "/users/admin"), message.getSender().getLink());
                            context.assertEquals("Hello everybody!", message.getContent());
                        } catch (IOException e) {
                            LOGGER.error(e);
                            context.fail();
                        } finally {
                            async.complete();
                        }
                    });
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testPostMessageIsPublic(TestContext context) {
        Async async = context.async();

        final ChatMessage newMessage = new ChatMessage()
                .setContent("hello from user!");

        final OffsetDateTime before = OffsetDateTime.now();

        request(POST, "/rooms/wellcome/messages", NO_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    res.bodyHandler(body -> {
                        try {
                            context.assertEquals(200, res.statusCode());
                            final OffsetDateTime after = OffsetDateTime.now();
                            final ChatMessage result = ChatMessage.parse(mimeType, body.toString());
                            context.assertEquals(newMessage.getContent(), result.getContent());
                            context.assertEquals(1, result.getIndex());
                            context.assertTrue(
                                    before.compareTo(result.getTimestamp()) < 0
                                            &&
                                            after.compareTo(result.getTimestamp()) > 0
                            );
                            context.assertEquals(new Link(BASE_URL + "/rooms/wellcome"), result.getChatRoom());
                        } catch (IOException e) {
                            context.fail();
                        } finally {
                            async.complete();
                        }
                    });
                }).end(
                newMessage.toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testGetUsersRequiresAuth(TestContext context) {
        Async async = context.async();

        request(GET, "/users", NO_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testGetUserRequiresAuth(TestContext context) {
        Async async = context.async();

        request(GET, "/users/admin", NO_TOKEN, NO_HEADER, NO_HEADER)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testPutUserRequiresAuth(TestContext context) {
        Async async = context.async();

        request(PUT, "/users/admin", NO_TOKEN, mimeType, APPLICATION_ANY)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end(
                new User().setUsername("whatever").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testPostRoomsRequiresAuth(TestContext context) {
        Async async = context.async();

        request(POST, "/rooms", NO_TOKEN, mimeType, APPLICATION_ANY)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end(
                new ChatRoom().setName("whatever").setAccessLevel(PUBLIC).toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }

    @Test
    public void testDeleteRoomRequiresAuth(TestContext context) {
        Async async = context.async();

        request(DELETE, "/rooms/wellcome", NO_TOKEN, NO_HEADER, APPLICATION_ANY)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end();


        async.await(MAX_WAIT);
    }

    @Test
    public void testGetMembersRequiresAuth(TestContext context) {
        Async async = context.async();

        request(GET, "/rooms/wellcome/members", NO_TOKEN, NO_HEADER, APPLICATION_ANY)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end();

        async.await(MAX_WAIT);
    }

    @Test
    public void testPostMembersRequiresAuth(TestContext context) {
        Async async = context.async();

        request(POST, "/rooms/wellcome/members", NO_TOKEN, mimeType, mimeType)
                .handler(res -> {
                    try {
                        context.assertTrue(401 == res.statusCode() ||  404 == res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end(
                new User().setUsername("whatever").toMIMETypeString(mimeType)
        );

        async.await(MAX_WAIT);
    }


    @Test
    public void testDeleteMembersRequiresAuth(TestContext context) {
        Async async = context.async();

        request(DELETE, "/rooms/wellcome/members/user", NO_TOKEN, NO_HEADER, APPLICATION_ANY)
                .handler(res -> {
                    try {
                        context.assertEquals(401, res.statusCode());
                    } finally {
                        async.complete();
                    }
                }).end();

        async.await(MAX_WAIT);
    }
}